/* Simulation code for DaeoDfba.Nonlinear_Example.ToyProblem generated by the OpenModelica Compiler OMCompiler v1.14.1. */
#if !defined(DaeoDfba_Nonlinear_Example_ToyProblem__MODEL_H)
#define DaeoDfba_Nonlinear_Example_ToyProblem__MODEL_H

#include "openmodelica.h"
#include "openmodelica_func.h"
#include "simulation_data.h"
#include "simulation/simulation_info_json.h"
#include "simulation/simulation_runtime.h"
#include "util/omc_error.h"
#include "util/parallel_helper.h"
#include "simulation/solver/model_help.h"
#include "simulation/solver/delay.h"
#include "simulation/solver/linearSystem.h"
#include "simulation/solver/nonlinearSystem.h"
#include "simulation/solver/mixedSystem.h"

#if defined(__cplusplus)
extern "C" {
#endif

#include <string.h>

#include "DaeoDfba.Nonlinear_Example.ToyProblem_functions.h"

#define DaeoDfba_Solver_solveNonlinearActiveSet_index 0
#define DaeoDfba_Solver_updateNonlinearActiveSet_index 1
#define DaeoDfba_Solver_NonlinearDaeoObject_constructor_index 2
#define DaeoDfba_Solver_NonlinearDaeoObject_destructor_index 3

extern void DaeoDfba_Nonlinear_Example_ToyProblem_callExternalObjectDestructors(DATA *_data, threadData_t *threadData);
#if !defined(OMC_NUM_NONLINEAR_SYSTEMS) || OMC_NUM_NONLINEAR_SYSTEMS>0
#endif
#if !defined(OMC_NUM_LINEAR_SYSTEMS) || OMC_NUM_LINEAR_SYSTEMS>0
#endif
#if !defined(OMC_NUM_MIXED_SYSTEMS) || OMC_NUM_MIXED_SYSTEMS>0
#endif
#if !defined(OMC_NO_STATESELECTION)
extern void DaeoDfba_Nonlinear_Example_ToyProblem_initializeStateSets(int nStateSets, STATE_SET_DATA* statesetData, DATA *data);
#endif
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionAlgebraics(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_function_storeDelayed(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_updateBoundVariableAttributes(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionInitialEquations(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionInitialEquations_lambda0(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionRemovedInitialEquations(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_updateBoundParameters(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_checkForAsserts(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_function_ZeroCrossings(DATA *data, threadData_t *threadData, double* gout);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_function_updateRelations(DATA *data, threadData_t *threadData, int evalZeroCross);
extern const char* DaeoDfba_Nonlinear_Example_ToyProblem_zeroCrossingDescription(int i, int **out_EquationIndexes);
extern const char* DaeoDfba_Nonlinear_Example_ToyProblem_relationDescription(int i);
extern void DaeoDfba_Nonlinear_Example_ToyProblem_function_initSample(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initialAnalyticJacobianG(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initialAnalyticJacobianA(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initialAnalyticJacobianB(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initialAnalyticJacobianC(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initialAnalyticJacobianD(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initialAnalyticJacobianF(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionJacG_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionJacA_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionJacB_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionJacC_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionJacD_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionJacF_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern const char* DaeoDfba_Nonlinear_Example_ToyProblem_linear_model_frame(void);
extern const char* DaeoDfba_Nonlinear_Example_ToyProblem_linear_model_datarecovery_frame(void);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_mayer(DATA* data, modelica_real** res, short *);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_lagrange(DATA* data, modelica_real** res, short *, short *);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_pickUpBoundsForInputsInOptimization(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_setInputData(DATA *data, const modelica_boolean file);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_getTimeGrid(DATA *data, modelica_integer * nsi, modelica_real**t);
extern void DaeoDfba_Nonlinear_Example_ToyProblem_function_initSynchronous(DATA * data, threadData_t *threadData);
extern void DaeoDfba_Nonlinear_Example_ToyProblem_function_updateSynchronous(DATA * data, threadData_t *threadData, long i);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_function_equationsSynchronous(DATA * data, threadData_t *threadData, long i);
extern void DaeoDfba_Nonlinear_Example_ToyProblem_read_input_fmu(MODEL_DATA* modelData, SIMULATION_INFO* simulationData);
extern void DaeoDfba_Nonlinear_Example_ToyProblem_function_savePreSynchronous(DATA *data, threadData_t *threadData);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_inputNames(DATA* data, char ** names);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_initializeDAEmodeData(DATA *data, DAEMODE_DATA*);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_functionLocalKnownVars(DATA*, threadData_t*);
extern int DaeoDfba_Nonlinear_Example_ToyProblem_symbolicInlineSystem(DATA*, threadData_t*);

#include "DaeoDfba.Nonlinear_Example.ToyProblem_literals.h"




#if defined(HPCOM) && !defined(_OPENMP)
  #error "HPCOM requires OpenMP or the results are wrong"
#endif
#if defined(_OPENMP)
  #include <omp.h>
#else
  /* dummy omp defines */
  #define omp_get_max_threads() 1
#endif

#if defined(__cplusplus)
}
#endif

#endif /* !defined(DaeoDfba_Nonlinear_Example_ToyProblem__MODEL_H) */


